// Datafeed implementation, will be added later
import Datafeed from "./datafeeds.js";
async function initReady() {

  getUserTimezone();
  const shareOverrides = {
    "paneProperties.legendProperties.showStudyArguments": false,
    "paneProperties.legendProperties.showStudyTitles": false,
    "paneProperties.legendProperties.showStudyValues": false,
    "paneProperties.legendProperties.showSeriesTitle": false,
    "paneProperties.legendProperties.showSeriesOHLC": false,
    "paneProperties.legendProperties.showLegend": false,
    "paneProperties.legendProperties.showBarChange": false,
    "paneProperties.crossHairProperties.style": 2,
    "paneProperties.crossHairProperties.width": 1,
    "scalesProperties.crosshairLabelBgColorLight": "#868686",
    "scalesProperties.crosshairLabelBgColorDark": "#868686",
    "scalesProperties.showStudyPlotLabels": false,
    "scalesProperties.showSeriesLastValue": false,
    "mainSeriesProperties.showPriceLine": false,
    "mainSeriesProperties.areaStyle.linewidth": 0.7,
    "linetoolposition.bodyFontSize": 8,
    "scalesProperties.showStudyLastValue": false,
    "mainSeriesProperties.priceLineColor": "#007FFF",
    timezone: timezone,
    "paneProperties.topMargin": 5,
    "paneProperties.bottomMargin": 5,
    "scalesProperties.fontSize": 10,
    ...overrides,
  };
  redirect("223");
  getDrawingRecord();

  window.tvWidget = new TradingView.widget({
    symbol: symbol, // default symbol
    interval: interval, // default interval
    fullscreen: true, // displays the chart in the fullscreen mode
    container: "tv_chart_container",
    datafeed: Datafeed,
    library_path: "charting_library/",
    timezone: timezone,
    custom_timezones: [
      customTimezone
    ],
    locale: locale,
    theme: theme,
    load_last_chart: true,
    loading_screen: loadingScreen,
    auto_save_delay: 1,
    custom_css_url: "../css/custom_css.css",
    enabled_features: [
      "header_widget",
      "chart_zoom",
      "pinch_scale",
      "save_chart_properties_to_local_storage",
      "move_logo_to_main_pane",
      "request_only_visible_range_on_reset",
      "iframe_loading_compatibility_mode",
      "studies_extend_time_scale",
      "determine_first_data_request_size_using_visible_range"
    ],
    disabled_features: [
      // "header_widget",
      "pane_context_menu",
      "header_fullscreen_button",
      "header_symbol_search",
      "header_compare",
      "use_localstorage_for_settings",
      "header_indicators",
      "header_interval_dialog_button",
      "header_resolutions",
      "header_search",
      "header_screenshot",
      "header_undo_redo",
      "header_chart_type",
      "go_to_date",
      "timeframes_toolbar",
      "left_toolbar",
      "header_settings",
      "legend_widget",
      "scales_context_menu",
      "main_series_scale_menu",
      "axis_pressed_mouse_move_scale",
      "control_bar",
      "volume_force_overlay",
      "widget_logo",
    ],
    overrides: overrides,
    saved_data: symbolChart,
    custom_font_family: "'OblivianTextMedium'",
    studies_overrides: {
      "macd.histogram.plottype": "columns",
      "macd.histogram.color.0": "#0BC5A4",
      "macd.histogram.color.1": "#0BC5A4",
      "macd.histogram.color.2": "#E24F1E",
      "macd.histogram.color.3": "#E24F1E",
      "macd.macd.color": "#5c94ff",
      "macd.signal.color": "#eee15b",
    },
    custom_indicators_getter: function (PineJS) {
      return Promise.resolve([
        {
          name: "KDJ",
          metainfo: {
            _metainfoVersion: 41,
            id: "KDJ-custom@tv-basicstudies-1",
            scriptIdPart: "",
            name: "KDJ",
            description: "KDJ",
            shortDescription: "KDJ",
            is_price_study: false,
            isCustomIndicator: true,
            canExtendTimeScale: true,
            defaults: {
              styles: {
                plot_1: {
                  linestyle: 0,
                  linewidth: 1, //红色
                  plottype: 0,
                  trackPrice: !1,
                  transparency: 0,
                  visible: !0,
                  color: "#007FFF",
                },
                plot_2: {
                  linestyle: 0,
                  linewidth: 1,
                  plottype: 0,
                  trackPrice: !1,
                  transparency: 0,
                  visible: !0,
                  color: "#0BC5A4",
                },
                plot_3: {
                  linestyle: 0,
                  linewidth: 1,
                  plottype: 0,
                  trackPrice: !1,
                  transparency: 0,
                  visible: !0,
                  color: "#d6c313",
                },
              },
              precision: 2 /**保留小数点 */,
              inputs: {
                in_0: 14,
                in_1: 1,
                in_2: 1,
                in_3: 1,
              },
            },
            plots: [
              {
                id: "plot_1",
                type: "line",
              },
              {
                id: "plot_2",
                type: "line",
              },
              {
                id: "plot_3",
                type: "line",
              },
            ],
            styles: {
              plot_1: {
                // Output name will be displayed in the Style window
                title: "Equity value",
                histogramBase: 0,
              },
              plot_2: {
                // Output name will be displayed in the Style window
                title: "Equity value",
                histogramBase: 0,
              },
              plot_3: {
                // Output name will be displayed in the Style window
                title: "Equity value",
                histogramBase: 0,
              },
            },
            inputs: [
              {
                id: "in_0",
                name: "Range Length(K Length)",
                defval: 14,
                type: "integer",
                min: 1,
                max: 2e3,
              },
              {
                id: "in_1",
                name: "K Smoothing Length",
                defval: 14,
                type: "integer",
                min: 1,
                max: 2e3,
              },
              {
                id: "in_2",
                name: "D Smoothing Length",
                defval: 1,
                type: "integer",
                min: 1,
                max: 2e3,
              },
              {
                id: "in_3",
                name: "J Smoothing Length",
                defval: 3,
                type: "integer",
                min: 1,
                max: 2e3,
              },
            ],
          },
          constructor: function () {
            this.init = function (context, inputCallback) {
              this._context = context;
              this._input = inputCallback;
            };
            this.main = function (a, b) {
              this._context = a;
              this._input = b;
              let RangeLength = this._input(0);
              let KsmoothLength = this._input(1);
              let DsmoothLength = this._input(2);
              let JsmoothLength = this._input(3);
              this._context.setMinimumAdditionalDepth(
                RangeLength + JsmoothLength
              );
              let close = this._context.new_unlimited_var(
                PineJS.Std.close(this._context)
              );
              let high = this._context.new_unlimited_var(
                PineJS.Std.high(this._context)
              );
              let low = this._context.new_unlimited_var(
                PineJS.Std.low(this._context)
              );
              var RSV = PineJS.Std.stoch(
                close,
                high,
                low,
                RangeLength,
                this._context
              );
              var K = 0.0;
              var D = 0.0;
              K +=
                0.666 * PineJS.Std.nz(K[1], 50) +
                0.334 * PineJS.Std.nz(RSV, 50);
              D +=
                0.666 * PineJS.Std.nz(D[1], 50) + 0.334 * PineJS.Std.nz(K, 50);
              let J = PineJS.Std.sma(
                this._context.new_var(3 * K - 2 * D),
                JsmoothLength,
                this._context
              );
              let K_Smoothed = PineJS.Std.sma(
                this._context.new_var(K),
                KsmoothLength,
                this._context
              );
              let D_Smoothed = PineJS.Std.sma(
                this._context.new_var(D),
                DsmoothLength,
                this._context
              );

              return [K_Smoothed, D_Smoothed, J];
            };
          },
        },
      ]);
    },
    custom_formatters: {
      dateFormatter: {
        format: (date) => {
          return date.getUTCMonth() + 1 + "/" + date.getUTCDate();
        },
      },
      timeFormatter: {
        format: (date) => {
          return (
            String(date.getUTCHours()).padStart(2, "0") +
            ":" +
            String(date.getUTCMinutes()).padStart(2, "0")
          );
        },
      },
      tickMarkFormatter: (date, tickMarkType) => {
        let day = String(date.getUTCDate()).padStart(2, "0");
        let month = String(date.getUTCMonth() + 1).padStart(2, "0");
        let year = date.getUTCFullYear();
        let time =
          String(date.getUTCHours()).padStart(2, "0") +
          ":" +
          String(date.getUTCMinutes()).padStart(2, "0");

        switch (tickMarkType) {
          case "Year":
            return year;

          case "Month":
            return month + "/" + year;

          case "DayOfMonth":
            return day + "/" + month;

          case "Time":
            return time;

          case "TimeWithSeconds":
            return time;
        }
      },
    },
  });

  window.tvWidget.onChartReady(function () {
    window.removeDrawingRecord = () => removeDrawingRecord();
    window.getDrawingRecord = () => getDrawingRecord();
    window.closeAllActiveLine = () => closeAllActiveLine();
    window.tvWidget.chart().getTimeScale().setBarSpacing(5);
    const priceScale1 = window.tvWidget.chart().getPanes()[0].getRightPriceScales()[0];
    priceScale1.setMode(1);

    // FE replace websocket
    import("./streaming_webview.js").then((myModule) => {
      window.reconnect = () => {
        redirect("223");
        myModule.reconnect();
        redirect("224");
      };

      window.getFromWebView = async (timestamp, ask, bid, rate) => {
        let result = null;
        await myModule
          .getFromWebView(timestamp, ask, bid, rate)
          .then((response) => {
            result = response;
          });
        return result;
      };
    });

    if (isTickChart) {
      window.tvWidget.chart().setChartType(getChartType("Area"));
    }

    window.tvWidget
      .chart()
      .getTimeScale()
      .barSpacingChanged()
      .subscribe(this, function (e) {
        if (e >= 84) {
          window.tvWidget.chart().getTimeScale().setBarSpacing(84);
        } else {
          window.tvWidget.chart().getTimeScale().setBarSpacing(e);
        }
        getMinAndMaxPrice();
      });

    window.tvWidget
      .changeTheme(theme.toLocaleLowerCase())
      .then(() => window.tvWidget.applyOverrides(shareOverrides));
    window.tvWidget.mainSeriesPriceFormatter()._priceScale = priceScale;
    window.tvWidget.chart().getTimeScale().defaultRightOffsetPercentage().setValue(0);

    if (symbolChart === null) {
      updateIndicator("MACD", "MACD");
    }

    const iframe = document.querySelector("iframe").contentDocument;

    const toggleTopDropdown = () => {
      openIndicatorSelection({
        value: window.currentMainIndicator,
        type: "main",
      });

      closeAllActiveLine();
    };

    const div = document.createElement("div");
    div.className = "topAppend";
    div.innerHTML = `
				<div id="topIndicator">
          <div>
          	<div id="currentIndicator">${window.currentMainIndicator}</div>
					  <div id="topIndicatorInfo">${currentMainIndicatorValue}</div>
          </div>
					<div class="arrowContainer"  id="indicatorArrow">
						<img src="${window.arrow}" class="indicatorArrow"/>
					</div>
				</div>	
		`;

    const targetElement = iframe.querySelector(
      "html body .chart-markup-table tr:first-child > td:nth-child(2) > div"
    );
    targetElement.appendChild(div);

    const topIndicator = iframe.getElementById("topIndicator");
    topIndicator.addEventListener("click", toggleTopDropdown);


    getMinAndMaxPrice();

    window.tvWidget
      .chart()
      .onIntervalChanged()
      .subscribe(null, function (changedInterval, obj) {
        interval = changedInterval;
      });

    window.tvWidget
      .chart()
      .onVisibleRangeChanged()
      .subscribe(null, ({ from, to }) => {
          getMinAndMaxPrice();
      });

    let current = null;

    window.tvWidget.subscribe("onTick", function (callback) {
      if (showAskPrice) {
        if (positionLine.ask) {
          window.tvWidget.chart().removeEntity(positionLine.ask);
        }

        positionLine.ask = window.tvWidget.chart().createShape({ price: askPrice },
							{
								shape: 'horizontal_line',
								disableSelection: true,
								disableSave: true,
								disableUndo: false,
								lock: true,
								zOrder: 'bottom',
								overrides: {
                  linecolor: 'rgba(233, 21, 69, 1)',
                  linewidth: 1,
                  linestyle: 2,
									showPrice: true,
									showLabel: true,
								}
							}
						)
      }

      if (showBidPrice) {
        if (positionLine.bid) {
          window.tvWidget.chart().removeEntity(positionLine.bid);
        }

        positionLine.bid = window.tvWidget.chart().createShape({ price: bidPrice },
          {
            shape: 'horizontal_line',
            disableSelection: true,
            disableSave: true,
            disableUndo: false,
            lock: true,
            zOrder: 'bottom',
            overrides: {
              linecolor: theme === 'Dark' ? 'rgba(0, 240, 255, 1)' : 'rgba(0, 81, 255, 1)',
              linewidth: 1,
              linestyle: 2,
              showPrice: true,
              showLabel: true
            }
          }
        )
      }

      let callbackTime = new Date(callback.time * 1000000);
      if (callbackTime.getTime() > current?.getTime()) {
        getMinAndMaxPrice();
      }
      current = callbackTime;
    });

    window.tvWidget.subscribe("onAutoSaveNeeded", function () {
      let shapes = window.tvWidget.chart().getAllShapes();
      let checkShape =
        shapes.length > 0 &&
        shapes.filter(
          (shape) =>
            shape.id !== positionLine?.ask && shape.id !== positionLine?.bid
        );
      if (checkShape.length > 0) {
        window.tvWidget.save(function (saveObject) {
          const { charts, layout } = saveObject;
          let save = { layout, charts };
          storeDrawingRecord(save);
        });
      } else if (
        shapes.filter(
          (shape) =>
            shape.id !== positionLine?.ask && shape.id !== positionLine?.bid
        ).length === 0
      ) {
        removeDrawingRecord();
      }
    });
    window.tvWidget.subscribe("drawing", function () {
      storeDrawingRecordBeforeClose();
    });

    window.tvWidget.subscribe("drawing_event", function (id, data) {
      if (data === "click") {
        checkActiveLine(id);
      }

      storeDrawingRecordBeforeClose();
    });

    window.tvWidget.chart().dataReady(() => {
      if (!isMobile) {
        setTimeout(
          () =>
            storeIndicators(
              {
                MA: [5, 10, 30],
                EMA: [5, 10, 30],
                BOLL: [25, 2],
                MACD: [12, 10, 9],
                KDJ: [14, 3, 3],
                RSI: [14],
                WR: [14],
              },
              "",
              "KDJ"
            ),
          0
        );
      }

      redirect("209");
      redirect("224");

      openChart(true);
    });
  });

  window.tvWidget.headerReady().then(function () {
    const iframe = document.querySelector("iframe").contentDocument;

    if (symbolChart != null) {
      window.tvWidget.setSymbol(symbol, interval, function () {});
    }
    var tickButton = window.tvWidget.createButton({ align: "left" });
    tickButton.setAttribute("title", text.tickChart[locale]);
    tickButton.textContent = text.tickChart[locale];
    tickButton.className = "timeFrame";
    tickButton.addEventListener("click", function () {
      redirect("223");
      window.tvWidget.setSymbol(symbol, 1, function () {});
      iframe
        .querySelector(".group-MBOVGQRI > .wrap-n5bmFxyX > .active")
        ?.classList.remove("active");
      this.classList.add("tick-active");
      isTickChart = true;
      window.tvWidget.chart().setChartType(getChartType("Area"), function(){ });
      getMinAndMaxPrice();
      changeInterval("0");
      redirect("224");
    });

    const btnList = [
      {
        label: "1m",
        resolution: 1,
      },
      {
        label: "5m",
        resolution: 5,
      },
      {
        label: "15m",
        resolution: 15,
      },
      {
        label: "30m",
        resolution: 30,
      },
      {
        label: "1H",
        resolution: 60,
      },
      {
        label: "4H",
        resolution: 240,
      },
      {
        label: "1D",
        resolution: "1D",
      },
      {
        label: "1W",
        resolution: "1W",
      },
      {
        label: "1M",
        resolution: "1M",
      },
    ];

    btnList.forEach(function (item, index) {
      var button = window.tvWidget.createButton({ align: "left" });
      button.setAttribute("title", item.resolution);
      button.textContent = item.label;
      button.className = "timeFrame";

      if (
        item.resolution == window.tvWidget.chart().resolution() &&
        isTickChart === false
      ) {
        button.classList.add("active");
      }

      if (index + 1 == btnList.length) {
        button.classList.add("last-interval");
      }
      button.addEventListener("click", function () {
        redirect("223");
        closeAllActiveLine();
        let clickedResolution = window.tvWidget.chart().resolution();

        if (clickedResolution == 240) {
          clickedResolution = "4H";
        } else if (clickedResolution == 1440) {
          clickedResolution = "1D";
        } else if (clickedResolution == 10080) {
          clickedResolution = "1W";
        } else if (clickedResolution == 43200) {
          clickedResolution = "1M";
        }

        changeInterval(item.resolution);

        if (item.resolution != clickedResolution) {
          iframe
            .querySelector(".group-MBOVGQRI > .wrap-n5bmFxyX > .active")
            ?.classList.remove("active");
          this.classList.add("active");
          window.tvWidget.chart().setChartType(getChartType(chartType));
          window.tvWidget.setSymbol(symbol, item.resolution, function () {
            getMinAndMaxPrice();
            redirect("224");
          });
        } else {
          this.classList.add("active");
          window.tvWidget.chart().setChartType(getChartType(chartType));
          getMinAndMaxPrice();
          redirect("224");
        }
        isTickChart = false;
        iframe
          .querySelector(".group-MBOVGQRI > .wrap-n5bmFxyX > .tick-active")
          ?.classList.remove("tick-active");
      });
    });


    if (isTickChart === true) {
      iframe
        .querySelector(".group-MBOVGQRI > .wrap-n5bmFxyX > .active")
        ?.classList.remove("active");
      tickButton.classList.add("tick-active");
    } else {
      window.tvWidget.chart().setChartType(getChartType(chartType));
    }

    
  });

  document.querySelector("iframe").addEventListener("load", function () {
    observeIframe();
    const iframe = document.querySelector("iframe");

    const indicators = iframe.contentDocument.querySelectorAll(
      ".topDropdownIndicator, .bottomDropdownIndicator"
    );
    indicators.forEach((indicator) => {
      indicator.addEventListener("click", handleIndicatorClick);
    });

    // Add click and touchend event listener to the iframe content
    iframe.contentDocument.body.addEventListener(
      "click",
      handleIframeContentClick
    );
    iframe.contentDocument.body.addEventListener(
      "touchend",
      handleIframeContentClick,
      { passive: false }
    );
  });
}

const handleIndicatorClick = (event) => {
  const element = event.target;
  const indicator = element.dataset.full_value;
  const shortValue = element.dataset.value;
  window.parent.updateIndicator(indicator, shortValue);
};

// Function to handle click and touchend events on the iframe content
const handleIframeContentClick = (event) => {
  const iframe = document.querySelector("iframe");
  if (event.target.tagName === "CANVAS") {
    closeAllActiveLine();
    if(iframe.contentDocument.querySelector("#bottomToast").style.display === "flex"){
      iframe.contentDocument.querySelector("#bottomToast").style.display = "none";
      iframe.contentDocument.querySelector("#bottomToastClose").setAttribute("data-clicked", "true");
    }
  }
  if(event.target.parentNode.id == 'bottomToastClose' || event.target.id === 'bottomToastClose'){
    if(iframe.contentDocument.getElementById("bottomToastClose").getAttribute('data-clicked') === "false"){
      iframe.contentDocument.getElementById("bottomToast").style.display = 'none';
      iframe.contentDocument.getElementById("bottomToastClose").setAttribute('data-clicked', 'true');
    }
  }

};

const observeIframe = () => {
  let counter = 0;
  const iframe = document.querySelector("iframe").contentDocument;
  // Create a new MutationObserver
  const observer = new MutationObserver(function (mutations) {
    // Check if the target element (#bottomIndicatorInfo) is added or modified
    if (
      iframe.querySelector("html body .chart-markup-table > tr:nth-child(3)") &&
      counter < 1
    ) {
      counter++;
      const div = document.createElement("div");
      div.className = "bottomAppend";
      div.innerHTML = `
				<div id="bottomIndicator">
          <div>
            <div id="currentBottomIndicator">${window.currentSubIndicator}</div>
            <div id="bottomIndicatorInfo"></div>
          </div>
					<div class="arrowContainer"  id="indicatorArrow">
						<img src="${window.arrow}" class="indicatorArrow"/>
					</div>
				</div>	
			
				
			`;
      const targetElement = iframe.querySelector(
        "html body .chart-markup-table > tr:nth-child(3)"
      );
      targetElement.appendChild(div);
      // Click event handler for the bottomIndicator
      function toggleBottomDropdown() {
        openIndicatorSelection({
          value: window.currentSubIndicator,
          type: "sub",
        });
        closeAllActiveLine();
      }

      const bottomIndicator = iframe.getElementById("bottomIndicator");
      bottomIndicator.addEventListener("click", toggleBottomDropdown);

      const div1 = document.createElement("div");
      div1.id = "bottomToast";
      div1.innerHTML = `
          <div id="bottomToastContainer">
            <p id="content">${text.orders_hint[lang]}</p>
            <div id="bottomToastClose" data-clicked="false">
              <img src='../hint-close.webp' />
            </div>
          </div>
			`;

      if(lang === 'ar'){
        div1.innerHTML = `
        <div id="bottomToastContainer">
          <div id="bottomToastClose" data-clicked="false">
            <img src='../hint-close.webp' />
          </div>
          <p id="content">${text.orders_hint[lang]}</p>
        </div>
    `;
      }
   
      targetElement.appendChild(div1);
      const bottomToastClose = iframe.getElementById("bottomToastClose");
      function toggleBottomToastClose(element) {
        if(element.target.getAttribute('data-clicked') === "false"){
          iframe.getElementById("bottomToast").style.display = 'none';
          element.target.setAttribute('data-clicked', 'true');
        }
      }

      bottomToastClose.addEventListener("click", toggleBottomToastClose);

      observer.disconnect();
    }
  });
  // Start observing the iframe's DOM changes
  observer.observe(iframe, { childList: true, subtree: true });
};


const getMinAndMaxPrice = async () => {
  fromTime = window.tvWidget.chart().getVisibleRange().from;
  toTime = window.tvWidget.chart().getVisibleRange().to;
  try{
    setTimeout(async () => {
      let bars = await window.tvWidget
            .chart()
            .exportData({
              includeTime: false,
              includeSeries: true,
              includeDisplayedValues: true,
              includeUserTime: true,
              from: fromTime,
              to: toTime,
            })
            .then((callback) => {
              return Promise.resolve(callback.data);
            });
          maxPrice = 0;
          minPrice = 99999;
          bars.forEach(function (bar, index) {
            let time = bar[0];
            let high = Math.max(bar[1], bar[2], bar[3], bar[4]);
            let low = Math.min(bar[1], bar[2], bar[3], bar[4]);
            if(isTickChart){
              high = bar[4];
              low = bar[1];
            }
              if (high > maxPrice) {
                maxPrice = high;
                maxPriceTime = time;
                maxPriceTime2 = index > 0 ? bars[index - 1][0] :  bars[index + 1][0];
              }
              if (low < minPrice) {
                minPrice = low;
                minPriceTime = time;
                minPriceTime2 = index > 0 ? bars[index - 1][0] :  bars[index + 1][0];
              }
          });
        
          minMaxcallback(minPrice, maxPrice, minPriceTime, minPriceTime2, maxPriceTime, maxPriceTime2);
    }, 0)
  }catch(e){

  }
};

const minMaxcallback = (minPrice, maxPrice, minPriceTime, minPriceTime2, maxPriceTime, maxPriceTime2) => {
  let textcolor = '#EDEDED'

  if(theme === 'Light'){
    textcolor = '#0051FF'
  }

  if(priceLabel.low) {
    window.tvWidget.chart().removeEntity(priceLabel.low);
  }

  priceLabel.low = window.tvWidget
    .chart()
      .createMultipointShape(
        [{ time: minPriceTime, price: minPrice }, { time: minPriceTime2, price: minPrice }], 
        { shape: 'trend_line', 
          disableSelection: true,
          disableSave: true,
          lock: true,
          overrides: {
            linecolor: 'rgba(0,0,0,0)',
            textcolor: textcolor,
            horzLabelsAlign: "left",
            vertLabelsAlign: "middle",
            fontsize: 9,
            visible: true,
            text: ` -- ${minPrice.toString()}`, 
            showLabel: true
          },
      });
 

  if(priceLabel.high) {
    window.tvWidget.chart().removeEntity(priceLabel.high);
  }
  priceLabel.high = window.tvWidget
      .chart()
      .createMultipointShape(
        [{ time: maxPriceTime, price: maxPrice }, { time: maxPriceTime2, price: maxPrice }], 
        { shape: 'trend_line', 
          disableSelection: true,
          disableSave: true,
          lock: true,
          overrides: {
            linecolor: 'rgba(0,0,0,0)',
            textcolor: textcolor,
            horzLabelsAlign: "left",
            vertLabelsAlign: "middle",
            fontsize: 9,
            visible: true,
            text: ` -- ${maxPrice.toString()}`, 
            showLabel: true
          },
      });
};


const checkActiveLine = (id) => {
  closeAllActiveLine();
  
  let type = "";
  Object.entries(positionLine).forEach(([key, value]) => {
    if (value?._line?._id === id || value === id) {
      type = key;
    }
  });
  if (type !== "") {
    setTimeout(() => activeLine(type), 0);
  } 

  return type;
};

const closeAllActiveLine = () => {
  Object.entries(positionLine).forEach(([key, value]) => {
    if (value !== null && key != "ask" && key != "bid") {
      if(!createdOrder || (createdOrder && value.ordernumber !== createdOrder.ordernumber)){
          value?.setCancelButtonBackgroundColor(priceLineInfo[value.type]?.backgroundColor)
              .setCancelButtonBorderColor(priceLineInfo[value.type]?.activeColor)
              .setCancelButtonIconColor(priceLineInfo[value.type]?.activeColor)
              .setBodyTextColor("#000")
              .setBodyBackgroundColor(priceLineInfo[value.type]?.backgroundColor)
              .setQuantityBackgroundColor(priceLineInfo[value.type]?.backgroundColor)
              .setQuantityBorderColor(priceLineInfo[value.type]?.backgroundColor)
              .setBodyBorderColor(priceLineInfo[value.type]?.activeColor) 
      }
    }
  });
  currentActivePositionLine = "";

};

const activeLine = (type) => {
  Object.entries(positionLine).forEach(([key, value]) => {
    if (key === type) {
      const iframe = document.querySelector("iframe").contentDocument;
      currentActivePositionLine = key;
      key !== "ask" && key !== "bid" && value
					.setBodyTextColor("#fff")
					.setBodyBorderColor(value.getLineColor())
					.setBodyBackgroundColor(value.getLineColor())
					.setQuantityBackgroundColor(value.getLineColor())
					.setQuantityBorderColor(value.getLineColor())
					.setCancelButtonIconColor("#000")
					.setCancelButtonBackgroundColor(value.getLineColor())
					.setCancelButtonBorderColor(value.getLineColor())
      
      if(key !== "ask" && key !== "bid" && 
      iframe.getElementById("bottomToastClose").getAttribute("data-clicked") === "false") iframe.querySelector("#bottomToast").style.display = "flex";
    }
  });
};

const compressData = (data) => {
  // Convert the array of objects to a JSON string
  const jsonString = JSON.stringify(data);

  // Compress the JSON string using Gzip with pako
  const compressedData = pako.gzip(jsonString);

  // Convert the compressed data to base64
  const base64EncodedData = btoa(
    String.fromCharCode.apply(null, compressedData)
  );

  return base64EncodedData;
};

const depressData = (data) => {
  // Decode the base64 data
  const compressedDataFromStorage = new Uint8Array(
    atob(data)
      .split("")
      .map((char) => char.charCodeAt(0))
  );

  // Decompress the Gzip data
  const decompressedJsonString = pako.ungzip(compressedDataFromStorage, {
    to: "string",
  });

  // Parse the decompressed JSON string back into an array of objects
  const decompressedData = JSON.parse(decompressedJsonString);

  return decompressedData;
};

const checkLocalStorageCanStore = () => {
  var data = "";
  for (var key in window.localStorage) {
    if (window.localStorage.hasOwnProperty(key)) {
      data += window.localStorage[key];
    }
  }

  const dataUsed = ((data.length * 16) / (8 * 1024)).toFixed(2);
  if (dataUsed > 4300) {
    cleanDrawingRecord();
  }

  return;
};

const cleanDrawingRecord = () => {
  let record = localStorage.getItem(drawingKey);

  if (record) {
    record = depressData(record);
    record.length > 0 ? record.shift() : null;
  }
};

const storeDrawingRecord = (data) => {
  checkLocalStorageCanStore();
  let record = localStorage.getItem(drawingKey);

  let acctValue = null;
  if (record) {
    record = depressData(record);

    Object.entries(record).forEach(([key, value]) => {
      if (value[symbol]) {
        value[symbol] = data;
        acctValue = data;
      }
    });
  } else {
    record = [];
  }

  if (acctValue == null) {
    record.push({ [symbol]: data });
  }

  if (record.length >= 20) {
    record.shift();
  }

  record = compressData(record);

  localStorage.setItem(drawingKey, record);
};

const removeDrawingRecord = () => {
  if (localStorage.getItem(drawingKey)) {
    let record = depressData(localStorage.getItem(drawingKey));

    if (record) {
      let final = record.filter(function (value) {
        return !value[symbol];
      });
      localStorage.setItem(drawingKey, compressData(final));
    }
  }
};

const storeDrawingRecordBeforeClose = () => {
  try {
    let shapes = window.tvWidget.chart().getAllShapes();
    let checkShapeChanges =
      shapes.length > 0 &&
      shapes.filter(
        (shape) =>
          shape.id !== positionLine?.ask && shape.id !== positionLine?.bid
      );
    if (checkShapeChanges.length > 0) {
      window.tvWidget.save(function (saveObject) {
        const { charts, layout } = saveObject;
        let save = { layout, charts };
        storeDrawingRecord(save);
      });
    }
  } catch (error) {
    localStorage.setItem("error", error, toString());
  }
};

const getDrawingRecord = () => {
  if (localStorage.getItem(drawingKey)) {
    const record = depressData(localStorage.getItem(drawingKey));
    if (record) {
      let search = record.filter(function (value) {
        return value[symbol];
      });
      if (search.length > 0) {
        symbolChart = search[0][symbol];
      }
    }
  }
  return symbolChart;
};

const openChart = (open) => {
  if(open){
        document.getElementById('tv_chart_container').style.display = 'block';
  }else{
        document.getElementById('tv_chart_container').style.display = 'none';
  }
}




window.addEventListener("DOMContentLoaded", initReady, false);

window.addEventListener(
  "unload",
  function () {
    storeDrawingRecordBeforeClose();
  },
  false
);


